<?php
/**
 * Main Controller
 * @copyright   Copyright (C) 2011 MicroEngine Inc.
 */
class Main_Controller extends Me_Controller
{
    /**
     * Controller名
     */
    protected $controller = 'Main';
    /**
     * Logicオブジェクト
     * @var Main_Logic
     */
    protected $logic;

    /**
     * 管理画面トップ
     */
    public function index()
    {
        $page_path = Me_Util::get_query_string('path', '/');
        $src = SITE_PATH . $page_path;
        $home = SITE_PATH;
        if (empty($home)) {
            $home = '/';
        }
        if ($_COOKIE['siteview_href']) {
            $src = $_COOKIE['siteview_href'];
        }
        $this->set_data(compact('src', 'home'));
    }

    /**
     * サイトビューで開いているページの情報を返す
     */
    public function get_info()
    {
        $pathname = urldecode(Me_Util::get_post_data('pathname', ''));
        list($page, $rows) = $this->logic->get_info($pathname);
        $this->set_data(compact('page', 'rows'));
    }

    /**
     * ログアウト処理
     */
    public function logout()
    {
        // POSTされていなければエラー
        if (empty($_POST)) {
            throw new Me_Exception(401);
        }

        // ログアウト処理実行
        $user_logic = new User_Logic();
        $user_logic->logout();

        // topにリダイレクト
        $this->redirect_path = '../Main/index';
    }

    /**
     * 空ページを返す
     */
    public function empty_page()
    {
        $this->view = null;
    }

    /**
     * フォームIDで管理しているフォームを削除する
     */
    public function unset_form()
    {
        Me_Util::unset_form();
        $this->view = null;
    }
}