<?php
/**
 * Metag Controller
 * @copyright   Copyright (C) 2011 MicroEngine Inc.
 */
class Metag_Controller extends Me_Controller
{
    const TAG_EDIT_FORM = 'tagEditForm';
    /**
     * Controller名
     */
    protected $controller = 'Metag';
    /**
     * Logicオブジェクト
     * @var Metag_Logic
     */
    protected $logic;

    /**
     * タグ生成フォーム表示
     */
    public function open()
    {
        $cls = isset($_GET['cls']) ? true : false;
        $selected_text = Me_Util::get_post_data('selected_text');
        $template_form_id = Me_Util::get_form_id();

        // セッションにオブジェクトが存在しないか、クリアフラグ有効の場合
        if (!isset($_SESSION[self::TAG_EDIT_FORM]) || $cls) {
            $type = Me_Util::get_post_data('type');
            if (!Metag_Logic::exist_type($type)) {
                throw new Me_Exception(607);
            }
            $class = 'Metag_' . ucfirst($type);
            $metag = new $class;
            $metag->set_initial_attr_value($selected_text);

            // sessionに保存
            $_SESSION[self::TAG_EDIT_FORM] = $metag;
        } else {
            //セッションにオブジェクトが存在する場合
            $metag = $_SESSION[self::TAG_EDIT_FORM];
        }

        $this->set_data(compact('metag', 'template_form_id'));
        $this->view = '/Metag/open_' . $metag->node_type . '.php';
    }

    /**
     * タグ生成処理
     */
    public function confirm()
    {
        if (isset($_SESSION[self::TAG_EDIT_FORM])) {
            $metag = $_SESSION[self::TAG_EDIT_FORM];
        } else {
            throw new Me_Exception(501);
        }
        $template_form_id = Me_Util::get_post_data('template_form_id');
        $form = Me_Util::get_form($template_form_id);

        $metag->set_post_data();
        $metag->generate_tag($form);

        $this->set_data(compact('metag'));
        $this->view = '/Metag/confirm.php';
    }
}