<?php
/**
 * Metag Attr
 * @package     Metag
 * @copyright   Copyright (C) 2011 MicroEngine Inc.
 */
class Metag_Attr extends Metag
{
    /**
     * タグタイプ
     * @var string
     */
    public $node_type = 'attr';
    /**
     * 表示名
     * @var string
     */
    public $display_name = '属性 (attr)';
    /**
     * ブロック要素かどうか
     * @var boolean
     */
    public $is_block = false;
    /**
     * 対象属性
     * @var string
     */
    public $target;
    /**
     * node_valueのプレフィックス
     * @var string
     */
    public $prefix;
    /**
     * node_valueのサフィックス
     * @var string
     */
    public $suffix;
    /**
     * 属性リスト
     * @var array
     */
    public $attr_list = array(
        'id' => 'id',
        'target' => 'target',
        'prefix' => 'prefix',
        'suffix' => 'suffix',
        'initial_value' => 'initial_value',
        'ref_id' => 'ref_id',
        'ref_page_id' => 'ref_page_id',
    );

    /**
     * 編集viewの開始タグ出力
     * @param array $row
     */
    public function edit_view($row)
    {
        $child = $this->get_child_node();
        echo $child->node_value;
    }

    /**
     * 出力
     */
    public function output($row, $edit_mode = false)
    {
        $child = $this->get_child_node();
        $ret = preg_replace(
                '/' . $this->target . '=(""|".*?[^\\\\]"|\'\'|\'.*?[^\\\\]\')/',
                $this->target . '="' . Me_Util::html_escape($this->prefix . $row['node_value'] . $this->suffix) . '"',
                $child->node_value);
        return $ret;
    }

    /**
     * タグ編集
     */
    public function set_post_data()
    {
        $mapping = $this->attr_list;
        $mapping['selected_text'] = 'selected_text';
        Me_Util::post_data_to_object($this, $mapping);
    }
}